unit main;

interface

{ =====

set debug level

ANYSPAN         *           any number of any chars
ANYCHAR         ?           match any single char
LITSTRING       "xxx"       match literal string
LITCHAR         #DDD        match single char, decimal code DDD
LITCHAR         \x          match single char
SPAN            [xyz]       match any included char
NOTSPAN         [-xyz]      match any EXCEPT included char
POSITION        @DDD        must be at string position DDD
PAREN           (xxx)       subset, treat as single pattern
OR              |           match left or right, but not both
NUMCHAR         %n          single number char only
ALPHACHAR       %a          single alpha char only - ignore case
ALNUMCHAR       %x          single alphanumeric char
NUMSPAN         %N          series of number chars
ALPHASPAN       %A          series of alpha chars
ALNUMSPAN       %X          series of alphanumeric chars
NOTNUMCHAR      %-n         anything except numeric char
NOTALPHACHAR    %-a         anything except alpha char
NOTALNUMCHAR    %-x         anything except alphanumeric char
NOTNUMSPAN      %-N         series of not-numerics
NOTALPHASPAN    %-A         series of not-alpha
NOTALNUMSPAN    %-X         series of not-alphanumerics
WHITECHAR       %w          single whitespace char
WHITESPAN       %W          series of whitespace
REPEAT          (DDD)       CURLY BRACES match next pattern exactly DDD times
REPEAT          (MIN:MAX)   CURLY BRACES match next pattern MIN to MAX times
event           !A          write anchor
event           !B          write bead
event           !S          write substring anchor to bead
event           !T          write substring 0 to bead



===== }



uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Outline, DirOutln,
    SGrep, ComCtrls, Buttons;


type
  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Rich1: TRichEdit;
    BitBtn1: TBitBtn;
    OpenDialog1: TOpenDialog;
    Static1: TStaticText;
    Static2: TStaticText;
    Edit2: TEdit;
    BitBtn2: TBitBtn;
    Memo1: TMemo;


    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure WriteMemo(Sender: TObject; Str: string);

  private
    { Private declarations }

  public
    { Public declarations }
  end;

var
  Form1: TForm1;


{ ---------------------------------------------------------------------------- }
{ ---------------------------------------------------------------------------- }


implementation

{$R *.DFM}

{ ---------------------------------------------------------------------------- }

procedure TForm1.FormCreate(Sender: TObject);
begin


end;

{ ---------------------------------------------------------------------------- }

procedure TForm1.BitBtn1Click(Sender: TObject);
var
    s:      string;
begin
if (OpenDialog1.Execute) then
    begin
    s := OpenDialog1.Filename;
    Edit1.Text := s;
    Rich1.Lines.LoadFromFile(s);
    Static1.Caption := IntToStr(Rich1.Lines.Count) + ' Lines';
    end;
end;

{ ---------------------------------------------------------------------------- }
{ scan thru the lines loaded in the RichEdit component, looking for the }
{ pattern given in the edit box.  when the pattern is found, highlight }
{ the text in red color }

procedure TForm1.BitBtn2Click(Sender: TObject);
var
    i,n:    integer;
    a,b:    integer;
    count:  integer;
    found:  boolean;
    sg:     TSGrep;
begin
Memo1.Lines.Clear;

// create a grep record and parse the pattern

// sg := TSimpleGrep.Create;
// sg.Pattern := Edit2.Text;

sg := TSGrep.CreateFromPattern(Edit2.Text);
sg.OnWrite := WriteMemo;
sg.OnError := WriteMemo;

// search thru all RichEdit text until pattern is not found

count := 0;
sg.Anchor := 0;
n := sg.MatchFirst(Rich1.Lines.Text);
while (n >= 0) do
    begin
    count := count + 1;
    Rich1.SelStart := sg.Anchor;
    Rich1.SelLength := sg.Bead - sg.Anchor;
    Rich1.SelAttributes.Color := clRed;

    Static2.Caption := IntToStr(sg.Anchor) + ' / ' + IntToStr(count);;
    Application.ProcessMessages;
    n := sg.MatchNext;
    end;

// notify user

Static2.Caption := IntToStr(count) + ' Matches';

// show him the opcode list

sg.Dump_OpList(Memo1.Lines);
end;

{ ---------------------------------------------------------------------------- }
{ fill in strings in the memo }

procedure TForm1.WriteMemo(Sender: TObject; Str: string);
var
    i,n:    integer;
    s:      string;
begin
n := TSGrep(Sender).Anchor;
s := '(' + IntToStr(n) + ') ' + Str;
Memo1.Lines.Add(s);
end;

end.
